﻿using Buddy.Coroutines;
using ff14bot;
using ff14bot.Managers;
using System.Threading.Tasks;
using UltimaCR.Spells.Main;

namespace UltimaCR.Rotations
{
    public sealed partial class Dragoon
    {
        private DragoonSpells _mySpells;

        private DragoonSpells MySpells
        {
            get { return _mySpells ?? (_mySpells = new DragoonSpells()); }
        }

        #region Class Spells

        private async Task<bool> TrueThrust()
        {
            if (Ultima.UltSettings.SmartTarget &&
		Helpers.EnemiesNearTarget(5) < 3 ||

		Ultima.UltSettings.SmartTarget &&
		Core.Player.CurrentTP < 320 ||	

		!Ultima.UltSettings.SmartTarget)
            {
                if (Core.Player.TargetDistance(4, false) ||

		    Ultima.LastSpell.Name == MySpells.Jump.Name &&
		    !MovementManager.IsMoving)
                {
                    return await MySpells.TrueThrust.Cast();
		}
            }
            return false;
        }

        private async Task<bool> Feint()
        {
            return await MySpells.Feint.Cast();
        }

        private async Task<bool> VorpalThrust()
        {
            if (Actionmanager.LastSpell.Name == MySpells.TrueThrust.Name)
		
            {
                if (!Actionmanager.HasSpell(MySpells.FullThrust.Name) &&
		    Ultima.LastSpell.Name == MySpells.TrueThrust.Name &&
		    Core.Player.CurrentTarget.CurrentHealth >= Core.Player.MaxHealth / 2 &&
		    Core.Player.HasTarget &&
		    Core.Player.InCombat && 
		    Core.Player.TargetDistance(4, false))
                {
                    if (await MySpells.LifeSurge.Cast())
                    {
                        await Coroutine.Wait(3000, () => Core.Player.HasAura(116));
                    }
                }
                return await MySpells.VorpalThrust.Cast();
            }
            return false;
        }

        private async Task<bool> KeenFlurry()
        {
            if (Ultima.LastSpell.Name != MySpells.Jump.Name &&
		Ultima.LastSpell.Name != MySpells.SpineshatterDive.Name &&
                Ultima.LastSpell.Name != MySpells.DragonfireDive.Name &&
		Ultima.LastSpell.Name != MySpells.LifeSurge.Name &&
		Ultima.LastSpell.Name != MySpells.LegSweep.Name &&
		Ultima.LastSpell.Name != MySpells.PowerSurge.Name &&
		Ultima.LastSpell.Name != MySpells.BloodForBlood.Name &&
		Ultima.LastSpell.Name != MySpells.BloodOfTheDragon.Name &&
		Ultima.LastSpell.Name != MySpells.Geirskogul.Name &&
		Ultima.LastSpell.Name != MySpells.Invigorate.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.InternalRelease.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.Bloodbath.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.SecondWind.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.MercyStroke.Name &&
		Core.Player.HasTarget &&
		Core.Player.InCombat &&
		Core.Player.TargetDistance(4, false))
            {
                if (Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth / 3 &&
		    Core.Player.CurrentTarget.IsFacing(Core.Player) &&
		    Core.Player.CurrentHealthPercent <= 50)
                {
                    return await MySpells.KeenFlurry.Cast();
		}
            }
            return false;
        }

        private async Task<bool> RaidOpenerImpulseDrive()
        {
            if (!Core.Player.CurrentTarget.HasAura(MySpells.Disembowel.Name))
            {
                if (Core.Player.CurrentTarget.CurrentHealthPercent >= 95 &&
		    Core.Player.CurrentTarget.MaxHealth > Core.Player.MaxHealth * 180)
                {
                    return await MySpells.ImpulseDrive.Cast();
		}
            }
            return false;
        }

        private async Task<bool> ImpulseDrive()
	{
            if (Ultima.UltSettings.SmartTarget &&
		Helpers.EnemiesNearTarget(5) < 3 ||
		!Ultima.UltSettings.SmartTarget)
            {
                if (Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2 &&
		    Actionmanager.HasSpell(MySpells.Disembowel.Name) &&
		    !Actionmanager.HasSpell(MySpells.ChaosThrust.Name) &&
                    !Core.Player.CurrentTarget.HasAura(MySpells.Disembowel.Name, false) &&
		    !Core.Player.CurrentTarget.HasAura(MySpells.Disembowel.Name, true)||

		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2 &&
		    Actionmanager.HasSpell(MySpells.Disembowel.Name) &&
		    Actionmanager.HasSpell(MySpells.ChaosThrust.Name) &&
		    !Core.Player.HasAura(MySpells.BloodOfTheDragon.Name) &&
                    !Core.Player.CurrentTarget.HasAura(MySpells.Disembowel.Name, false) &&
		    !Core.Player.CurrentTarget.HasAura(MySpells.Disembowel.Name, true)||

		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2 &&
                    Actionmanager.HasSpell(MySpells.Disembowel.Name) &&
		    Actionmanager.HasSpell(MySpells.ChaosThrust.Name) &&
		    Core.Player.HasAura(MySpells.BloodOfTheDragon.Name) &&
                    !Core.Player.CurrentTarget.HasAura(MySpells.Disembowel.Name, false) &&
		    !Core.Player.CurrentTarget.HasAura(MySpells.Disembowel.Name, true)||

		

		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2 &&
		    Actionmanager.HasSpell(MySpells.Disembowel.Name) &&
		    !Actionmanager.HasSpell(MySpells.ChaosThrust.Name) &&
		    Core.Player.CurrentTarget.HasAura(MySpells.Disembowel.Name, true) &&
                    !Core.Player.CurrentTarget.HasAura(MySpells.Disembowel.Name, true, 6000) ||

		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2 &&
		    Actionmanager.HasSpell(MySpells.Disembowel.Name) &&
		    Actionmanager.HasSpell(MySpells.ChaosThrust.Name) &&
		    !Core.Player.HasAura(MySpells.BloodOfTheDragon.Name) &&
		    Core.Player.CurrentTarget.HasAura(MySpells.Disembowel.Name, true) &&
                    !Core.Player.CurrentTarget.HasAura(MySpells.Disembowel.Name, true, 10000) ||

		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2 &&
                    Actionmanager.HasSpell(MySpells.Disembowel.Name) &&
		    Actionmanager.HasSpell(MySpells.ChaosThrust.Name) &&
		    Core.Player.HasAura(MySpells.BloodOfTheDragon.Name) &&
		    Core.Player.CurrentTarget.HasAura(MySpells.Disembowel.Name, true) &&
                    !Core.Player.CurrentTarget.HasAura(MySpells.Disembowel.Name, true, 10000))
                {
                    return await MySpells.ImpulseDrive.Cast();
		}
            }
            return false;
        }

        private async Task<bool> LegSweep()
        {
            if (Ultima.UltSettings.DragoonLegSweep &&
		Ultima.LastSpell.Name != MySpells.Jump.Name &&
		Ultima.LastSpell.Name != MySpells.SpineshatterDive.Name &&
                Ultima.LastSpell.Name != MySpells.DragonfireDive.Name &&
		Ultima.LastSpell.Name != MySpells.LifeSurge.Name &&
		Ultima.LastSpell.Name != MySpells.PowerSurge.Name &&
		Ultima.LastSpell.Name != MySpells.BloodForBlood.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.InternalRelease.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.Bloodbath.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.SecondWind.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.MercyStroke.Name &&
		Ultima.LastSpell.Name != MySpells.BloodOfTheDragon.Name &&
		Ultima.LastSpell.Name != MySpells.Geirskogul.Name &&
		Ultima.LastSpell.Name != MySpells.KeenFlurry.Name &&
		Ultima.LastSpell.Name != MySpells.Invigorate.Name &&
		!Core.Player.HasAura(802) &&
		!Core.Player.HasAura(803) &&
		!Core.Player.HasAura(120))
            {
                if (Ultima.UltSettings.DragoonLegSweep &&
		    !Actionmanager.HasSpell(MySpells.HeavyThrust.Name) ||

		    Core.Player.CurrentTarget.CurrentHealth <= Core.Player.MaxHealth * 2 &&
		    Core.Player.HasAura(MySpells.HeavyThrust.Name, false, 3000) ||
		
		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2 &&
		    Actionmanager.HasSpell(MySpells.Disembowel.Name) &&
		    Core.Player.CurrentTarget.HasAura(MySpells.Disembowel.Name) &&
		    Core.Player.HasAura(MySpells.HeavyThrust.Name, true, 3000))
                {
                    return await MySpells.LegSweep.Cast();
		}
            }
            return false;
        }

        private async Task<bool> HeavyThrust()
        {
            if (Core.Player.CurrentTarget.CurrentHealth >= Core.Player.MaxHealth / 2 ||

		Helpers.EnemiesNearTarget(5) > 1)
            {
                if (!Actionmanager.HasSpell(MySpells.FullThrust.Name) &&
		    !Core.Player.HasAura(MySpells.HeavyThrust.Name, false, 3000) ||

		    Actionmanager.HasSpell(MySpells.FullThrust.Name) &&
		    !Actionmanager.HasSpell(MySpells.FangAndClaw.Name) &&
		    !Core.Player.HasAura(MySpells.HeavyThrust.Name, false, 6000) ||

		    Actionmanager.HasSpell(MySpells.FangAndClaw.Name) &&
		    Core.Player.HasAura(MySpells.BloodOfTheDragon.Name, true, 10000) &&
		    !Actionmanager.CanCast(MySpells.BloodOfTheDragon.Name, Core.Player) &&
		    !Core.Player.HasAura(MySpells.HeavyThrust.Name, false, 8000) ||

		    Actionmanager.HasSpell(MySpells.FangAndClaw.Name) &&
		    Actionmanager.CanCast(MySpells.BloodOfTheDragon.Name, Core.Player) &&
		    !Core.Player.HasAura(MySpells.HeavyThrust.Name, false, 8000) ||

		    Actionmanager.HasSpell(MySpells.FangAndClaw.Name) &&
		    !Core.Player.HasAura(MySpells.BloodOfTheDragon.Name) &&
		    !Core.Player.HasAura(MySpells.HeavyThrust.Name, false, 6000))
                {
                    return await MySpells.HeavyThrust.Cast();
		}
            }
            return false;
        }

        private async Task<bool> PiercingTalon()
        {
            if (Core.Player.TargetDistance(10))
            {
                return await MySpells.PiercingTalon.Cast();
            }
            return false;
        }

        private async Task<bool> LifeSurge()
        {
            if (Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth / 2 &&
		Core.Player.HasTarget &&
	        Core.Player.InCombat && 
	        Core.Player.TargetDistance(4, false))
            {
                if (!Actionmanager.HasSpell(MySpells.FullThrust.Name) &&
		    !Actionmanager.HasSpell(MySpells.ImpulseDrive.Name) &&
		    Actionmanager.LastSpell.Name == MySpells.TrueThrust.Name ||

		    !Actionmanager.HasSpell(MySpells.FullThrust.Name) &&
		    Actionmanager.HasSpell(MySpells.ImpulseDrive.Name) &&
		    Actionmanager.LastSpell.Name == MySpells.HeavyThrust.Name ||

		    Actionmanager.LastSpell.Name == MySpells.VorpalThrust.Name)
                {
                    return await MySpells.LifeSurge.Cast();
		}
            }
            return false;
        }

        private async Task<bool> Invigorate()
       {
            if (Core.Player.CurrentTP < 540 &&
		Ultima.LastSpell.Name != MySpells.Jump.Name &&
		Ultima.LastSpell.Name != MySpells.SpineshatterDive.Name &&
                Ultima.LastSpell.Name != MySpells.DragonfireDive.Name &&
		Ultima.LastSpell.Name != MySpells.LifeSurge.Name &&
		Ultima.LastSpell.Name != MySpells.LegSweep.Name &&
		Ultima.LastSpell.Name != MySpells.PowerSurge.Name &&
		Ultima.LastSpell.Name != MySpells.BloodForBlood.Name &&
		Ultima.LastSpell.Name != MySpells.BloodOfTheDragon.Name &&
		Ultima.LastSpell.Name != MySpells.Geirskogul.Name &&
		Ultima.LastSpell.Name != MySpells.KeenFlurry.Name &&
		Ultima.LastSpell.Name != MySpells.Invigorate.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.InternalRelease.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.Bloodbath.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.SecondWind.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.MercyStroke.Name &&
		Core.Player.HasTarget &&
		Core.Player.InCombat &&
		Core.Player.TargetDistance(4, false))
            {
                if (Ultima.UltSettings.SmartTarget &&
		    Helpers.EnemiesNearTarget(8) > 2 &&
		    Core.Player.CurrentTarget.CurrentHealthPercent > 40 ||
		
		    !Ultima.UltSettings.SmartTarget &&
		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth)
                {
                    return await MySpells.Invigorate.Cast();
		}
            }
            return false;
        }

        private async Task<bool> FullThrust()
        {
            if (Actionmanager.LastSpell.Name == MySpells.VorpalThrust.Name)
		
            {
                if (Ultima.LastSpell.Name == MySpells.VorpalThrust.Name &&
		    Actionmanager.HasSpell(MySpells.FullThrust.Name) &&
		    Core.Player.CurrentTarget.CurrentHealth >= Core.Player.MaxHealth / 2 &&
		    Core.Player.HasTarget &&
		    Core.Player.InCombat && 
		    Core.Player.TargetDistance(4, false))
                {
                    if (await MySpells.LifeSurge.Cast())
                    {
                        await Coroutine.Wait(3000, () => Core.Player.HasAura(116));
                    }
                }
                return await MySpells.FullThrust.Cast();
            }
            return false;
        }

        private async Task<bool> RaidOpenerPhlebotomize()
        {
            if (!Core.Player.CurrentTarget.HasAura(MySpells.Phlebotomize.Name, true))
            {
                if (Core.Player.CurrentTarget.CurrentHealthPercent >= 95 &&
		    Core.Player.CurrentTarget.MaxHealth > Core.Player.MaxHealth * 180)
                {
                    return await MySpells.Phlebotomize.Cast();
		}
            }
            return false;
        }


        private async Task<bool> Phlebotomize()
        {
            if (!Ultima.UltSettings.MultiTarget &&
		!Actionmanager.HasSpell(MySpells.Disembowel.Name) &&
		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2 &&
		!Core.Player.CurrentTarget.HasAura(MySpells.Phlebotomize.Name, true, 6000) ||


		!Ultima.UltSettings.MultiTarget &&
		Actionmanager.HasSpell(MySpells.Disembowel.Name) &&
		Core.Player.CurrentTarget.HasAura(MySpells.Disembowel.Name, false) &&
		!Core.Player.CurrentTarget.HasAura(MySpells.Disembowel.Name, true) &&
		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2 &&
		!Core.Player.HasAura(MySpells.BloodOfTheDragon.Name) &&
		!Core.Player.CurrentTarget.HasAura(MySpells.Phlebotomize.Name, true, 6000) ||

		!Ultima.UltSettings.MultiTarget &&
		Actionmanager.HasSpell(MySpells.Disembowel.Name) &&
		Core.Player.CurrentTarget.HasAura(MySpells.Disembowel.Name, false) &&
		!Core.Player.CurrentTarget.HasAura(MySpells.Disembowel.Name, true) &&
		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2 &&
		Core.Player.HasAura(MySpells.BloodOfTheDragon.Name, true, 8000) &&
		!Core.Player.CurrentTarget.HasAura(MySpells.Phlebotomize.Name, true, 8000) ||

		Ultima.UltSettings.MultiTarget &&
		Actionmanager.HasSpell(MySpells.Disembowel.Name) &&
		Core.Player.CurrentTarget.HasAura(MySpells.Disembowel.Name, false) &&
		!Core.Player.CurrentTarget.HasAura(MySpells.Disembowel.Name, true) &&
		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2 &&
		!Core.Player.HasAura(MySpells.BloodOfTheDragon.Name) &&
		Core.Player.CurrentTarget.HasAura(MySpells.Phlebotomize.Name, true) &&
		!Core.Player.CurrentTarget.HasAura(MySpells.Phlebotomize.Name, true, 6000) ||

		Ultima.UltSettings.MultiTarget &&
		Actionmanager.HasSpell(MySpells.Disembowel.Name) &&
		Core.Player.CurrentTarget.HasAura(MySpells.Disembowel.Name, false) &&
		!Core.Player.CurrentTarget.HasAura(MySpells.Disembowel.Name, true) &&
		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2 &&
		Core.Player.HasAura(MySpells.BloodOfTheDragon.Name, true, 8000) &&
		Core.Player.CurrentTarget.HasAura(MySpells.Phlebotomize.Name, true) &&
		!Core.Player.CurrentTarget.HasAura(MySpells.Phlebotomize.Name, true, 8000) ||



		!Ultima.UltSettings.MultiTarget &&
		Actionmanager.HasSpell(MySpells.Disembowel.Name) &&
		Core.Player.CurrentTarget.HasAura(MySpells.Disembowel.Name, true, 6000) &&
		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2 &&
		!Core.Player.HasAura(MySpells.BloodOfTheDragon.Name) &&
		!Core.Player.CurrentTarget.HasAura(MySpells.Phlebotomize.Name, true, 6000) ||

		!Ultima.UltSettings.MultiTarget &&
		Actionmanager.HasSpell(MySpells.Disembowel.Name) &&
		Core.Player.CurrentTarget.HasAura(MySpells.Disembowel.Name, true, 8000) &&
		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2 &&
		Core.Player.HasAura(MySpells.BloodOfTheDragon.Name, true, 8000) &&
		!Core.Player.CurrentTarget.HasAura(MySpells.Phlebotomize.Name, true, 8000) ||

		Ultima.UltSettings.MultiTarget &&
		Actionmanager.HasSpell(MySpells.Disembowel.Name) &&
		Core.Player.CurrentTarget.HasAura(MySpells.Disembowel.Name, true, 8000) &&
		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth &&
		!Core.Player.HasAura(MySpells.BloodOfTheDragon.Name) &&
		Core.Player.CurrentTarget.HasAura(MySpells.Phlebotomize.Name, true) &&
		!Core.Player.CurrentTarget.HasAura(MySpells.Phlebotomize.Name, true, 6000) ||

		Ultima.UltSettings.MultiTarget &&
		Actionmanager.HasSpell(MySpells.Disembowel.Name) &&
		Core.Player.CurrentTarget.HasAura(MySpells.Disembowel.Name, true, 8000) &&
		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth &&
		Core.Player.HasAura(MySpells.BloodOfTheDragon.Name, true, 8000) &&
		Core.Player.CurrentTarget.HasAura(MySpells.Phlebotomize.Name, true) &&
		!Core.Player.CurrentTarget.HasAura(MySpells.Phlebotomize.Name, true, 8000))
            {
                return await MySpells.Phlebotomize.Cast();
            }
            return false;
        }

        private async Task<bool> BloodForBlood()
        {
            if (Ultima.LastSpell.Name != MySpells.Jump.Name &&
		Ultima.LastSpell.Name != MySpells.SpineshatterDive.Name &&
                Ultima.LastSpell.Name != MySpells.DragonfireDive.Name &&
		Ultima.LastSpell.Name != MySpells.LifeSurge.Name &&
		Ultima.LastSpell.Name != MySpells.LegSweep.Name &&
		Ultima.LastSpell.Name != MySpells.PowerSurge.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.InternalRelease.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.Bloodbath.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.SecondWind.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.MercyStroke.Name &&
		Ultima.LastSpell.Name != MySpells.BloodOfTheDragon.Name &&
		Ultima.LastSpell.Name != MySpells.Geirskogul.Name &&
		Ultima.LastSpell.Name != MySpells.KeenFlurry.Name &&
		Ultima.LastSpell.Name != MySpells.Invigorate.Name &&
		Core.Player.HasTarget &&
		Core.Player.InCombat &&
		Core.Player.TargetDistance(4, false))
            {
                if (Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth ||

		    Core.Player.CurrentTarget.CurrentHealth <= Core.Player.MaxHealth &&
		    Core.Player.CurrentTarget.CurrentHealthPercent > 70)
                {
                    return await MySpells.BloodForBlood.Cast();
		}
            }
            return false;
        }

        private async Task<bool> Disembowel()
        {
            if (Actionmanager.LastSpell.Name == MySpells.ImpulseDrive.Name)
            {
                return await MySpells.Disembowel.Cast();
            }
            return false;
        }

        private async Task<bool> DoomSpike()
        {
            if (!Core.Player.HasAura(116) &&
		Core.Player.CurrentTP >= 320 &&
		Helpers.EnemiesNearTarget(6) > 2 &&
		Ultima.LastSpell.Name != MySpells.LifeSurge.Name &&
		Core.Player.HasAura(MySpells.HeavyThrust.Name, true, 3000))
            {
                return await MySpells.DoomSpike.Cast();
            }
            return false;
        }

        private async Task<bool> RingOfThorns()
        {
            if (Actionmanager.LastSpell.Name == MySpells.HeavyThrust.Name)
            {
                return await MySpells.RingOfThorns.Cast();
            }
            return false;
        }

        private async Task<bool> ChaosThrust()
        {
            if (Actionmanager.LastSpell.Name == MySpells.Disembowel.Name)
            {
                return await MySpells.ChaosThrust.Cast();
            }
            return false;
        }

        #endregion

        #region Cross Class Spells

        #region Marauder

        private async Task<bool> Foresight()
        {
            if (Ultima.UltSettings.DragoonForesight)
            {
                return await MySpells.CrossClass.Foresight.Cast();
            }
            return false;
        }

        private async Task<bool> SkullSunder()
        {
            if (Ultima.UltSettings.DragoonSkullSunder)
            {
                return await MySpells.CrossClass.SkullSunder.Cast();
            }
            return false;
        }

        private async Task<bool> Fracture()
        {
            if (Ultima.UltSettings.DragoonFracture &&
                !Core.Player.CurrentTarget.HasAura(MySpells.CrossClass.Fracture.Name, true, 4000))
            {
                return await MySpells.CrossClass.Fracture.Cast();
            }
            return false;
        }

        private async Task<bool> Bloodbath()
        {
            if (Ultima.LastSpell.Name != MySpells.Jump.Name &&
		Ultima.LastSpell.Name != MySpells.SpineshatterDive.Name &&
                Ultima.LastSpell.Name != MySpells.DragonfireDive.Name &&
		Ultima.LastSpell.Name != MySpells.LifeSurge.Name &&
		Ultima.LastSpell.Name != MySpells.LegSweep.Name &&
		Ultima.LastSpell.Name != MySpells.PowerSurge.Name &&
		Ultima.LastSpell.Name != MySpells.BloodForBlood.Name &&
		Ultima.LastSpell.Name != MySpells.BloodOfTheDragon.Name &&
		Ultima.LastSpell.Name != MySpells.Geirskogul.Name &&
		Ultima.LastSpell.Name != MySpells.KeenFlurry.Name &&
		Ultima.LastSpell.Name != MySpells.Invigorate.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.InternalRelease.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.SecondWind.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.MercyStroke.Name &&
		Core.Player.HasTarget &&
		Core.Player.InCombat &&
		Core.Player.TargetDistance(4, false))
            {
                if (Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth / 2 &&
		    Core.Player.CurrentHealthPercent <= 50 ||
		
		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth / 2 &&
		    Core.Player.CurrentTarget.IsFacing(Core.Player) &&
		    Core.Player.CurrentHealthPercent <= 70)
                {
                    return await MySpells.CrossClass.Bloodbath.Cast();
		}
            }
            return false;
        }

        private async Task<bool> MercyStroke()
        {
            if (Ultima.LastSpell.Name != MySpells.Jump.Name &&
		Ultima.LastSpell.Name != MySpells.SpineshatterDive.Name &&
                Ultima.LastSpell.Name != MySpells.DragonfireDive.Name &&
		Ultima.LastSpell.Name != MySpells.LifeSurge.Name &&
		Ultima.LastSpell.Name != MySpells.LegSweep.Name &&
		Ultima.LastSpell.Name != MySpells.PowerSurge.Name &&
		Ultima.LastSpell.Name != MySpells.BloodForBlood.Name &&
		Ultima.LastSpell.Name != MySpells.BloodOfTheDragon.Name &&
		Ultima.LastSpell.Name != MySpells.Geirskogul.Name &&
		Ultima.LastSpell.Name != MySpells.KeenFlurry.Name &&
		Ultima.LastSpell.Name != MySpells.Invigorate.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.InternalRelease.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.Bloodbath.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.MercyStroke.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.SecondWind.Name)
            {
                if (Ultima.UltSettings.DragoonMercyStroke)
                {
                    return await MySpells.CrossClass.MercyStroke.Cast();
		}
            }
            return false;
        }

        #endregion

        #region Pugilist

        private async Task<bool> Featherfoot()
        {
            if (Ultima.UltSettings.DragoonFeatherfoot)
            {
                return await MySpells.CrossClass.Featherfoot.Cast();
            }
            return false;
        }

        private async Task<bool> SecondWind()
        {
            if (Ultima.LastSpell.Name != MySpells.Jump.Name &&
		Ultima.LastSpell.Name != MySpells.SpineshatterDive.Name &&
                Ultima.LastSpell.Name != MySpells.DragonfireDive.Name &&
		Ultima.LastSpell.Name != MySpells.LifeSurge.Name &&
		Ultima.LastSpell.Name != MySpells.LegSweep.Name &&
		Ultima.LastSpell.Name != MySpells.PowerSurge.Name &&
		Ultima.LastSpell.Name != MySpells.BloodForBlood.Name &&
		Ultima.LastSpell.Name != MySpells.BloodOfTheDragon.Name &&
		Ultima.LastSpell.Name != MySpells.Geirskogul.Name &&
		Ultima.LastSpell.Name != MySpells.KeenFlurry.Name &&
		Ultima.LastSpell.Name != MySpells.Invigorate.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.InternalRelease.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.Bloodbath.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.MercyStroke.Name &&
		Core.Player.InCombat)
            {
                if (Core.Player.CurrentHealthPercent <= 30 ||
		
		    Core.Player.CurrentTarget.IsFacing(Core.Player) &&
		    Core.Player.HasTarget &&
		    Core.Player.TargetDistance(4, false) &&
		    Core.Player.CurrentHealthPercent <= 60)
                {
                    return await MySpells.CrossClass.SecondWind.Cast();
		}
            }
            return false;
        }

        private async Task<bool> Haymaker()
        {
            if (Ultima.UltSettings.DragoonHaymaker)
            {
                return await MySpells.CrossClass.Haymaker.Cast();
            }
            return false;
        }

        private async Task<bool> InternalRelease()
        {
            if (Ultima.UltSettings.DragoonInternalRelease &&
		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth &&
		Ultima.LastSpell.Name != MySpells.Jump.Name &&
		Ultima.LastSpell.Name != MySpells.SpineshatterDive.Name &&
                Ultima.LastSpell.Name != MySpells.DragonfireDive.Name &&
		Ultima.LastSpell.Name != MySpells.LifeSurge.Name &&
		Ultima.LastSpell.Name != MySpells.LegSweep.Name &&
		Ultima.LastSpell.Name != MySpells.PowerSurge.Name &&
		Ultima.LastSpell.Name != MySpells.BloodForBlood.Name &&
		Ultima.LastSpell.Name != MySpells.BloodOfTheDragon.Name &&
		Ultima.LastSpell.Name != MySpells.Geirskogul.Name &&
		Ultima.LastSpell.Name != MySpells.KeenFlurry.Name &&
		Ultima.LastSpell.Name != MySpells.Invigorate.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.Bloodbath.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.MercyStroke.Name &&
		Core.Player.HasTarget &&
		Core.Player.InCombat &&
		Core.Player.TargetDistance(4, false))
            {
                if (Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth ||
		
		    Core.Player.CurrentTarget.CurrentHealth <= Core.Player.MaxHealth &&
		    Core.Player.CurrentTarget.CurrentHealthPercent > 70)
                {
                    return await MySpells.CrossClass.InternalRelease.Cast();
		}
            }
            return false;
        }

        private async Task<bool> Mantra()
        {
            if (Ultima.UltSettings.DragoonMantra)
            {
                return await MySpells.CrossClass.Mantra.Cast();
            }
            return false;
        }

        #endregion

        #endregion

        #region Job Spells

        private async Task<bool> Jump()
	{
            if (Ultima.UltSettings.DragoonJump &&
		!MovementManager.IsMoving &&
		!Actionmanager.CanCast(MySpells.PowerSurge.Name, Core.Player) &&
		Ultima.LastSpell.Name != MySpells.SpineshatterDive.Name &&
                Ultima.LastSpell.Name != MySpells.DragonfireDive.Name &&
		Ultima.LastSpell.Name != MySpells.LifeSurge.Name &&
		Ultima.LastSpell.Name != MySpells.LegSweep.Name &&
		Ultima.LastSpell.Name != MySpells.PowerSurge.Name &&
		Ultima.LastSpell.Name != MySpells.BloodForBlood.Name &&
		Ultima.LastSpell.Name != MySpells.KeenFlurry.Name &&
		Ultima.LastSpell.Name != MySpells.Invigorate.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.InternalRelease.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.Bloodbath.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.SecondWind.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.MercyStroke.Name &&
		Ultima.LastSpell.Name != MySpells.BloodOfTheDragon.Name &&
		Ultima.LastSpell.Name != MySpells.Geirskogul.Name &&
		Core.Player.HasAura(MySpells.HeavyThrust.Name, false, 4000) &&
		!Core.Player.HasAura(116) &&
		!Core.Player.HasAura(802) &&
		!Core.Player.HasAura(803) &&
		Core.Player.TargetDistance(4, false))
		
            {
                if (Core.Player.HasAura(120) ||

		    !Actionmanager.HasSpell(MySpells.Disembowel.Name) &&
		    !Actionmanager.HasSpell(MySpells.BloodOfTheDragon.Name) ||

		    Core.Player.CurrentTarget.CurrentHealth <= Core.Player.MaxHealth * 2  ||

		    Actionmanager.HasSpell(MySpells.Disembowel.Name) &&
		    !Actionmanager.HasSpell(MySpells.BloodOfTheDragon.Name) &&
		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2  &&
		    Core.Player.CurrentTarget.HasAura(MySpells.Disembowel.Name, false, 4000) ||

		    Actionmanager.HasSpell(MySpells.Disembowel.Name) &&
		    Actionmanager.HasSpell(MySpells.BloodOfTheDragon.Name) &&
		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2 &&
		    Core.Player.CurrentTarget.HasAura(MySpells.Disembowel.Name, false, 4000) &&
		    !Core.Player.HasAura(MySpells.BloodOfTheDragon.Name) &&
		    !Actionmanager.CanCast(MySpells.BloodOfTheDragon.Name, Core.Player) ||

		    Actionmanager.HasSpell(MySpells.Disembowel.Name) &&
		    Actionmanager.HasSpell(MySpells.BloodOfTheDragon.Name) &&
		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2 &&
		    Core.Player.CurrentTarget.HasAura(MySpells.Disembowel.Name, false, 4000) &&
		    Core.Player.HasAura(MySpells.BloodOfTheDragon.Name, true, 10000) &&
		    Ultima.LastSpell.Name != MySpells.FullThrust.Name ||

		    Actionmanager.HasSpell(MySpells.Disembowel.Name) &&
		    Actionmanager.HasSpell(MySpells.BloodOfTheDragon.Name) &&
		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2 &&
		    Core.Player.CurrentTarget.HasAura(MySpells.Disembowel.Name, false, 4000) &&
		    Core.Player.HasAura(MySpells.BloodOfTheDragon.Name, true, 10000) &&
		    Ultima.LastSpell.Name != MySpells.ChaosThrust.Name)
		{
                    return await MySpells.Jump.Cast();
		}
            }
            return false;
        }

        private async Task<bool> ElusiveJump()
        {
            return await MySpells.ElusiveJump.Cast();
        }

        private async Task<bool> SpineshatterDive()
        {
            if (Ultima.UltSettings.DragoonSpineshatterDive &&
		!MovementManager.IsMoving &&
		Ultima.LastSpell.Name != MySpells.Jump.Name &&
                Ultima.LastSpell.Name != MySpells.DragonfireDive.Name &&
		Ultima.LastSpell.Name != MySpells.LifeSurge.Name &&
		Ultima.LastSpell.Name != MySpells.LegSweep.Name &&
		Ultima.LastSpell.Name != MySpells.PowerSurge.Name &&
		Ultima.LastSpell.Name != MySpells.BloodForBlood.Name &&
		Ultima.LastSpell.Name != MySpells.KeenFlurry.Name &&
		Ultima.LastSpell.Name != MySpells.Invigorate.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.InternalRelease.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.Bloodbath.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.SecondWind.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.MercyStroke.Name &&
		Ultima.LastSpell.Name != MySpells.BloodOfTheDragon.Name &&
		Ultima.LastSpell.Name != MySpells.Geirskogul.Name &&
		Core.Player.HasAura(MySpells.HeavyThrust.Name, false, 4000) &&
		!Core.Player.HasAura(116) &&
		!Core.Player.HasAura(802) &&
		!Core.Player.HasAura(803) &&
		Core.Player.TargetDistance(4, false) ||

		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2 &&
		!Ultima.UltSettings.DragoonSpineshatterDive &&
		Core.Player.InCombat &&
		Core.Player.CurrentTarget.CurrentHealthPercent < 94 &&
		Core.Player.TargetDistance(12, true) &&
                Ultima.LastSpell.Name != MySpells.DragonfireDive.Name && 
		Helpers.EnemiesNearTarget(5) < 2 ||

		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2 &&
		!Ultima.UltSettings.DragoonSpineshatterDive &&
		Core.Player.InCombat &&
		Core.Player.CurrentTarget.CurrentHealthPercent < 94 &&
		Core.Player.TargetDistance(12, true) &&
                Ultima.LastSpell.Name != MySpells.DragonfireDive.Name &&
		!Actionmanager.CanCast(MySpells.SpineshatterDive.Name, Core.Player.CurrentTarget))
            {
                if (Core.Player.HasAura(120) &&
		    !Actionmanager.CanCast(MySpells.Jump.Name, Core.Player.CurrentTarget) ||

		    Core.Player.CurrentTarget.CurrentHealth <= Core.Player.MaxHealth * 2 ||

		    Actionmanager.HasSpell(MySpells.Disembowel.Name) &&
		    !Actionmanager.HasSpell(MySpells.BloodOfTheDragon.Name) &&
		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2 &&
		    Core.Player.CurrentTarget.HasAura(MySpells.Disembowel.Name, false, 4000) ||

		    Actionmanager.HasSpell(MySpells.Disembowel.Name) &&
		    Actionmanager.HasSpell(MySpells.BloodOfTheDragon.Name) &&
		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2 &&
		    !Core.Player.HasAura(MySpells.BloodOfTheDragon.Name) &&
		    !Actionmanager.CanCast(MySpells.BloodOfTheDragon.Name, Core.Player) ||

		    Actionmanager.HasSpell(MySpells.Disembowel.Name) &&
		    Actionmanager.HasSpell(MySpells.BloodOfTheDragon.Name) &&
		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2 &&
		    Core.Player.CurrentTarget.HasAura(MySpells.Disembowel.Name, false, 4000) &&
		    Core.Player.HasAura(MySpells.BloodOfTheDragon.Name, true, 10000) &&
		    Ultima.LastSpell.Name != MySpells.FullThrust.Name ||

		    Actionmanager.HasSpell(MySpells.Disembowel.Name) &&
		    Actionmanager.HasSpell(MySpells.BloodOfTheDragon.Name) &&
		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2 &&
		    Core.Player.CurrentTarget.HasAura(MySpells.Disembowel.Name, false, 4000) &&
		    Core.Player.HasAura(MySpells.BloodOfTheDragon.Name, true, 10000) &&
		    Ultima.LastSpell.Name != MySpells.ChaosThrust.Name)
			
                {
                    return await MySpells.SpineshatterDive.Cast();
		}
            }
            return false;
        }

        private async Task<bool> PowerSurge()
        {
            if (Ultima.UltSettings.DragoonPowerSurge &&
		Core.Player.InCombat &&
		!MovementManager.IsMoving &&
		Ultima.LastSpell.Name != MySpells.Jump.Name &&
		Ultima.LastSpell.Name != MySpells.SpineshatterDive.Name &&
                Ultima.LastSpell.Name != MySpells.DragonfireDive.Name &&
		Ultima.LastSpell.Name != MySpells.LifeSurge.Name &&
		Ultima.LastSpell.Name != MySpells.LegSweep.Name &&
		Ultima.LastSpell.Name != MySpells.BloodForBlood.Name &&
		Ultima.LastSpell.Name != MySpells.KeenFlurry.Name &&
		Ultima.LastSpell.Name != MySpells.Invigorate.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.InternalRelease.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.Bloodbath.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.SecondWind.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.MercyStroke.Name &&
		Ultima.LastSpell.Name != MySpells.BloodOfTheDragon.Name &&
		Ultima.LastSpell.Name != MySpells.Geirskogul.Name &&
		Core.Player.HasAura(MySpells.HeavyThrust.Name, false, 4000) &&
		!Core.Player.HasAura(116) &&
		!Core.Player.HasAura(802) &&
		!Core.Player.HasAura(803))
	    {
                if (Core.Player.CurrentTarget.CurrentHealth <= Core.Player.MaxHealth * 2 &&
		    Actionmanager.CanCast(MySpells.Jump.Name, Core.Player.CurrentTarget) ||


		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2 &&
		    Actionmanager.CanCast(MySpells.Jump.Name, Core.Player.CurrentTarget) &&
		    Core.Player.CurrentTarget.HasAura(MySpells.Disembowel.Name, false, 4000) &&
		    !Core.Player.HasAura(MySpells.BloodOfTheDragon.Name) ||

		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2 &&
		    Actionmanager.CanCast(MySpells.Jump.Name, Core.Player.CurrentTarget) &&
		    Core.Player.CurrentTarget.HasAura(MySpells.Disembowel.Name, false, 4000) &&
		    Core.Player.HasAura(MySpells.BloodOfTheDragon.Name, true, 5000) &&
		    Ultima.LastSpell.Name != MySpells.FullThrust.Name ||

		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2 &&
		    Actionmanager.CanCast(MySpells.Jump.Name, Core.Player.CurrentTarget) &&
		    Core.Player.CurrentTarget.HasAura(MySpells.Disembowel.Name, false, 4000) &&
		    Core.Player.HasAura(MySpells.BloodOfTheDragon.Name, true, 5000) &&
		    Ultima.LastSpell.Name != MySpells.ChaosThrust.Name ||


		    Ultima.UltSettings.DragoonSpineshatterDive &&
		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2 &&
		    !Actionmanager.CanCast(MySpells.Jump.Name, Core.Player.CurrentTarget) &&
		    Actionmanager.CanCast(MySpells.SpineshatterDive.Name, Core.Player.CurrentTarget) &&
		    Core.Player.CurrentTarget.HasAura(MySpells.Disembowel.Name, false, 4000) &&
		    !Core.Player.HasAura(MySpells.BloodOfTheDragon.Name) &&
		    !Actionmanager.CanCast(MySpells.BloodOfTheDragon.Name, Core.Player) ||

		    Ultima.UltSettings.DragoonSpineshatterDive &&
		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2 &&
		    !Actionmanager.CanCast(MySpells.Jump.Name, Core.Player.CurrentTarget) &&
		    Actionmanager.CanCast(MySpells.SpineshatterDive.Name, Core.Player.CurrentTarget) &&
		    Core.Player.CurrentTarget.HasAura(MySpells.Disembowel.Name, false, 4000) &&
		    Core.Player.HasAura(MySpells.BloodOfTheDragon.Name, true, 5000) &&
		    Ultima.LastSpell.Name != MySpells.FullThrust.Name ||

		    Ultima.UltSettings.DragoonSpineshatterDive &&
		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2 &&
		    !Actionmanager.CanCast(MySpells.Jump.Name, Core.Player.CurrentTarget) &&
		    Actionmanager.CanCast(MySpells.SpineshatterDive.Name, Core.Player.CurrentTarget) &&
		    Core.Player.CurrentTarget.HasAura(MySpells.Disembowel.Name, false, 4000) &&
		    Core.Player.HasAura(MySpells.BloodOfTheDragon.Name, true, 5000) &&
		    Ultima.LastSpell.Name != MySpells.ChaosThrust.Name)
		{
                    return await MySpells.PowerSurge.Cast();
		}
            }
            return false;
        }

        private async Task<bool> DragonfireDive()
        {
            if (Ultima.UltSettings.DragoonDragonfireDive &&
		!MovementManager.IsMoving &&
		Ultima.LastSpell.Name != MySpells.Jump.Name &&
		Ultima.LastSpell.Name != MySpells.SpineshatterDive.Name &&
		Ultima.LastSpell.Name != MySpells.LifeSurge.Name &&
		Ultima.LastSpell.Name != MySpells.LegSweep.Name &&
		Ultima.LastSpell.Name != MySpells.PowerSurge.Name &&
		Ultima.LastSpell.Name != MySpells.BloodForBlood.Name &&
		Ultima.LastSpell.Name != MySpells.KeenFlurry.Name &&
		Ultima.LastSpell.Name != MySpells.Invigorate.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.InternalRelease.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.Bloodbath.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.SecondWind.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.MercyStroke.Name &&
		Ultima.LastSpell.Name != MySpells.BloodOfTheDragon.Name &&
		Ultima.LastSpell.Name != MySpells.Geirskogul.Name &&
		Core.Player.HasAura(MySpells.HeavyThrust.Name, false, 4000) &&
		!Core.Player.HasAura(116) &&
		!Core.Player.HasAura(802) &&
		!Core.Player.HasAura(803) ||

		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2 &&
		!Ultima.UltSettings.DragoonDragonfireDive &&
		Core.Player.InCombat &&
		Core.Player.CurrentTarget.CurrentHealthPercent < 94 &&
		Core.Player.TargetDistance(12, true) &&
		Ultima.LastSpell.Name != MySpells.SpineshatterDive.Name &&
		Helpers.EnemiesNearTarget(5) > 1 ||
		
		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2 &&
		!Ultima.UltSettings.DragoonDragonfireDive &&
		Core.Player.InCombat &&
		Core.Player.CurrentTarget.CurrentHealthPercent < 94 &&
		Core.Player.TargetDistance(12, true) &&
		Ultima.LastSpell.Name != MySpells.SpineshatterDive.Name &&
		!Actionmanager.CanCast(MySpells.SpineshatterDive.Name, Core.Player.CurrentTarget))
            {
                if (Core.Player.CurrentTarget.CurrentHealth <= Core.Player.MaxHealth * 2 ||

		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2 &&
		    Core.Player.CurrentTarget.HasAura(MySpells.Disembowel.Name, false, 4000) &&
		    !Core.Player.HasAura(MySpells.BloodOfTheDragon.Name) ||

		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2 &&
		    Core.Player.CurrentTarget.HasAura(MySpells.Disembowel.Name, false, 4000) &&
		    Core.Player.HasAura(MySpells.BloodOfTheDragon.Name, true, 10000) &&
		    Ultima.LastSpell.Name != MySpells.FullThrust.Name ||

		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2 &&
		    Core.Player.CurrentTarget.HasAura(MySpells.Disembowel.Name, false, 4000) &&
		    Core.Player.HasAura(MySpells.BloodOfTheDragon.Name, true, 10000) &&
		    Ultima.LastSpell.Name != MySpells.ChaosThrust.Name)
                {
                    return await MySpells.DragonfireDive.Cast();
		}
            }
            return false;
        }

        private async Task<bool> BattleLitany()
        {
            if (Ultima.UltSettings.DragoonBattleLitany &&
		!MovementManager.IsMoving &&
		Core.Player.InCombat &&
		Core.Player.HasTarget &&
		Core.Player.TargetDistance(4, false) &&
		Ultima.LastSpell.Name != MySpells.Jump.Name &&
		Ultima.LastSpell.Name != MySpells.SpineshatterDive.Name &&
                Ultima.LastSpell.Name != MySpells.DragonfireDive.Name &&
		Ultima.LastSpell.Name != MySpells.LifeSurge.Name &&
		Ultima.LastSpell.Name != MySpells.LegSweep.Name &&
		Ultima.LastSpell.Name != MySpells.PowerSurge.Name &&
		Ultima.LastSpell.Name != MySpells.BloodForBlood.Name &&
		Ultima.LastSpell.Name != MySpells.KeenFlurry.Name &&
		Ultima.LastSpell.Name != MySpells.Invigorate.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.InternalRelease.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.Bloodbath.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.SecondWind.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.MercyStroke.Name &&
		Ultima.LastSpell.Name != MySpells.BloodOfTheDragon.Name &&
		Ultima.LastSpell.Name != MySpells.Geirskogul.Name &&
		Core.Player.HasAura(MySpells.HeavyThrust.Name, false, 4000) &&
		!Core.Player.HasAura(116) &&
		!Core.Player.HasAura(786))
            {
                if (Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2 ||

		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth &&
		    Helpers.EnemiesNearTarget(5) > 3)
                {
                    return await MySpells.BattleLitany.Cast();
		}
            }
            return false;
        }

        private async Task<bool> BloodOfTheDragon()
        {
            if (Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2 &&
		Core.Player.HasTarget &&
		Core.Player.InCombat &&
		Core.Player.TargetDistance(4, false) &&
		!Core.Player.HasAura(MySpells.BloodOfTheDragon.Name) ||

		Actionmanager.CanCast(MySpells.BloodOfTheDragon.Name, Core.Player) &&
		Core.Player.InCombat &&
		Core.Player.HasAura(MySpells.BloodOfTheDragon.Name) &&
		!Core.Player.HasAura(MySpells.BloodOfTheDragon.Name, false, 3000) ||

		Core.Player.HasTarget &&
		Core.Player.InCombat &&
		Helpers.EnemiesNearTarget(4) > 1 &&
		!Core.Player.HasAura(MySpells.BloodOfTheDragon.Name))
            {
                if (Ultima.LastSpell.Name == MySpells.Disembowel.Name ||
                    Ultima.LastSpell.Name == MySpells.VorpalThrust.Name)
                {
                    return await MySpells.BloodOfTheDragon.Cast();
                }
            }
            return false;
        }

        private async Task<bool> FangAndClaw()
        {
            return await MySpells.FangAndClaw.Cast();
        }

        private async Task<bool> WheelingThrust()
        {
            return await MySpells.WheelingThrust.Cast();
        }

        private async Task<bool> Geirskogul()
        {
            if (Actionmanager.LastSpell.Name == MySpells.FullThrust.Name ||
                Actionmanager.LastSpell.Name == MySpells.ChaosThrust.Name)
            {
                if (!Actionmanager.CanCast(MySpells.BloodOfTheDragon.Name, Core.Player) &&
		    Core.Player.HasAura(MySpells.BloodOfTheDragon.Name, true, 17000) ||

		    Actionmanager.CanCast(MySpells.BloodOfTheDragon.Name, Core.Player) &&
		    Core.Player.HasAura(MySpells.BloodOfTheDragon.Name, true, 15000))
                {
                    return await MySpells.Geirskogul.Cast();
		}
            }
            return false;
        }

        #endregion

        #region PvP Spells

        private async Task<bool> Enliven()
        {
            return await MySpells.PvP.Enliven.Cast();
        }

        private async Task<bool> FetterWard()
        {
            return await MySpells.PvP.FetterWard.Cast();
        }

        private async Task<bool> ImpulseRush()
        {
            return await MySpells.PvP.ImpulseRush.Cast();
        }

        private async Task<bool> Purify()
        {
            return await MySpells.PvP.Purify.Cast();
        }

        private async Task<bool> Skewer()
        {
            return await MySpells.PvP.Skewer.Cast();
        }

        private async Task<bool> WeaponThrow()
        {
            return await MySpells.PvP.WeaponThrow.Cast();
        }

        #endregion
    }
}