﻿using ff14bot;
using ff14bot.Managers;
using System.Linq;
using System.Threading.Tasks;
using UltimaCR.Spells.Main;

namespace UltimaCR.Rotations
{
    public sealed partial class Machinist
    {
        private MachinistSpells _mySpells;

        private MachinistSpells MySpells
        {
            get { return _mySpells ?? (_mySpells = new MachinistSpells()); }
        }

        #region Job Spells

        private async Task<bool> SplitShot()
        {
            if (!Core.Player.HasAura(851) &&
		Ultima.LastSpell.Name != MySpells.Reassemble.Name)
            {
                if (!Core.Player.HasAura(856) &&
		    !Core.Player.HasAura(857) ||

		    !Core.Player.HasAura(856))
                {
                    return await MySpells.SplitShot.Cast();
		}
            }
            return false;
        }

        private async Task<bool> SlugShot()
        {
            if (!Actionmanager.HasSpell(MySpells.CleanShot.Name) &&
		Core.Player.HasAura(856) ||
		Actionmanager.HasSpell(MySpells.CleanShot.Name) &&
		!Core.Player.HasAura(851) &&
		Core.Player.HasAura(856) &&
		!Core.Player.HasAura(857))
            {
                return await MySpells.SlugShot.Cast();
            }
            return false;
        }
        private async Task<bool> Reload()
        {
            if (!Core.Player.InCombat &&
		!Core.Player.HasAura(862) ||

		Core.Player.InCombat &&
		!Actionmanager.HasSpell(MySpells.HotShot.Name) &&
		!Core.Player.HasAura(862) ||

		Core.Player.InCombat &&
		Actionmanager.HasSpell(MySpells.HotShot.Name) &&
		!Actionmanager.HasSpell(MySpells.Wildfire.Name) &&
		!Core.Player.HasAura(862) &&
                Core.Player.HasAura(MySpells.HotShot.Name, true, 9000) ||

		Core.Player.InCombat &&
		Core.Player.CurrentTarget.CurrentHealth <= Core.Player.MaxHealth * 2 &&
		Actionmanager.HasSpell(MySpells.Wildfire.Name) &&
		!Core.Player.HasAura(862) &&
		Core.Player.HasAura(MySpells.HotShot.Name, true, 9000) ||

		Core.Player.InCombat &&
		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2 &&
		Actionmanager.HasSpell(MySpells.Wildfire.Name) &&
		!Actionmanager.CanCast(MySpells.Wildfire.Name, Core.Player.CurrentTarget) &&
		!Core.Player.HasAura(862) &&
		Core.Player.HasAura(MySpells.HotShot.Name, true, 9000))
            {
                return await MySpells.Reload.Cast();
            }
            return false;
        }

        private async Task<bool> QuickReload()
        {
            if (Core.Player.InCombat &&
		Ultima.LastSpell.Name != MySpells.Reload.Name &&
		!Core.Player.HasAura(862) ||
		
		Core.Player.InCombat &&
		Actionmanager.HasSpell(MySpells.QuickReload.Name) &&
		!Actionmanager.CanCast(MySpells.Reload.Name, Core.Player) &&
		Ultima.LastSpell.Name != MySpells.Reload.Name ||

		Core.Player.InCombat &&
		Actionmanager.HasSpell(MySpells.QuickReload.Name) &&
		!Actionmanager.CanCast(MySpells.Reload.Name, Core.Player) &&
		Ultima.LastSpell.Name != MySpells.Reload.Name &&
		Core.Player.HasAura(MySpells.HotShot.Name, true, 5000) ||

		Core.Player.InCombat &&
		Ultima.LastSpell.Name != MySpells.Reload.Name &&
		!Core.Player.HasTarget &&
		!Core.Player.InCombat)
            {
                return await MySpells.QuickReload.Cast();
            }
            return false;
        }

        private async Task<bool> RaidOpenerLeadShot()
        {
            if (Core.Player.CurrentTarget.CurrentHealthPercent >= 92 &&
		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 10 &&
		!Core.Player.HasAura(851) &&
		!Core.Player.CurrentTarget.HasAura(MySpells.LeadShot.Name, true))
            {
                return await MySpells.LeadShot.Cast();
            }
            return false;
        }

        private async Task<bool> LeadShot()
        {
            if (Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * .70 &&
		!Core.Player.HasAura(851) &&
		!Core.Player.HasAura(862) &&
		Ultima.LastSpell.Name != MySpells.Reload.Name &&
		Ultima.LastSpell.Name != MySpells.QuickReload.Name &&
		!Core.Player.CurrentTarget.HasAura(MySpells.LeadShot.Name, true, 4000))
            {
                return await MySpells.LeadShot.Cast();
            }
            return false;
        }

        private async Task<bool> Heartbreak()
        {
            if (Ultima.LastSpell.Name != MySpells.CrossClass.RagingStrikes.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.HawksEye.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.BloodForBlood.Name &&
		Ultima.LastSpell.Name != MySpells.Blank.Name &&
		Ultima.LastSpell.Name != MySpells.Reload.Name &&
		Ultima.LastSpell.Name != MySpells.Heartbreak.Name &&
		Ultima.LastSpell.Name != MySpells.LegGraze.Name &&
		Ultima.LastSpell.Name != MySpells.Reassemble.Name &&
		Ultima.LastSpell.Name != MySpells.FootGraze.Name &&
		Ultima.LastSpell.Name != MySpells.QuickReload.Name &&
		Ultima.LastSpell.Name != MySpells.RapidFire.Name &&
		Ultima.LastSpell.Name != MySpells.HeadGraze.Name &&
		Ultima.LastSpell.Name != MySpells.Wildfire.Name &&
		Ultima.LastSpell.Name != MySpells.RookAutoturret.Name &&
		Ultima.LastSpell.Name != MySpells.Promotion.Name &&
		Ultima.LastSpell.Name != MySpells.SuppressiveFire.Name &&
		Ultima.LastSpell.Name != MySpells.BishopAutoturret.Name &&
		Ultima.LastSpell.Name != MySpells.Dismantle.Name &&
		Ultima.LastSpell.Name != MySpells.GaussRound.Name &&
		Ultima.LastSpell.Name != MySpells.RendMind.Name &&
		Ultima.LastSpell.Name != MySpells.Hypercharge.Name &&
		Ultima.LastSpell.Name != MySpells.Ricochet.Name)
            {
                if (!Ultima.UltSettings.SingleTarget &&
		    Ultima.UltSettings.MachinistHeartbreak ||

		    Ultima.UltSettings.SingleTarget &&
		    Core.Player.CurrentTarget.CurrentHealth < Core.Player.MaxHealth * 4 &&
		    Ultima.UltSettings.MachinistHeartbreak ||

		    Ultima.UltSettings.SingleTarget &&
		    Core.Player.CurrentTarget.CurrentHealth >= Core.Player.MaxHealth * 4 &&
		    Ultima.UltSettings.MachinistHeartbreak &&
		    !Actionmanager.CanCast(MySpells.Wildfire.Name, Core.Player.CurrentTarget))
                {
                    return await MySpells.Heartbreak.Cast();
		}
            }
            return false;
        }

        private async Task<bool> LegGraze()
        {
            return await MySpells.LegGraze.Cast();
        }

        private async Task<bool> Reassemble()
        {
            if (!Actionmanager.HasSpell(MySpells.CleanShot.Name) &&
		Ultima.LastSpell.Name != MySpells.SlugShot.Name &&
		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth / 3 &&
		Core.Player.HasAura(856) ||

		Actionmanager.HasSpell(MySpells.CleanShot.Name) &&
		Ultima.LastSpell.Name != MySpells.CleanShot.Name &&
		Core.Player.CurrentTarget.CurrentHealth >= Core.Player.MaxHealth / 4 &&
		Core.Player.CurrentTarget.CurrentHealth <= Core.Player.MaxHealth &&
		!Core.Player.HasAura(856) &&
		Core.Player.HasAura(857) ||

		Core.Player.CurrentTarget.CurrentHealthPercent >= 80 &&
		!Actionmanager.CanCast(MySpells.Wildfire.Name, Core.Player) &&
		Actionmanager.HasSpell(MySpells.CleanShot.Name) &&
		Ultima.LastSpell.Name != MySpells.CleanShot.Name &&
		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth &&
		!Core.Player.HasAura(856) &&
		Core.Player.HasAura(857) &&
		Core.Player.HasAura(MySpells.HotShot.Name, true, 5000) ||

		Core.Player.CurrentTarget.CurrentHealthPercent < 80 &&
		Actionmanager.HasSpell(MySpells.CleanShot.Name) &&
		Ultima.LastSpell.Name != MySpells.CleanShot.Name &&
		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth &&
		!Core.Player.HasAura(856) &&
		Core.Player.HasAura(857) &&
		Core.Player.HasAura(MySpells.HotShot.Name, true, 5000) ||

		Actionmanager.HasSpell(MySpells.CleanShot.Name) &&
		Ultima.LastSpell.Name != MySpells.CleanShot.Name &&
		Core.Player.CurrentTarget.CurrentHealth >= Core.Player.MaxHealth / 4 &&
		Core.Player.CurrentTarget.CurrentHealth <= Core.Player.MaxHealth &&
		Core.Player.HasAura(856) &&
		Core.Player.HasAura(857) ||

		Core.Player.CurrentTarget.CurrentHealthPercent >= 80 &&
		!Actionmanager.CanCast(MySpells.Wildfire.Name, Core.Player) &&
		Actionmanager.HasSpell(MySpells.CleanShot.Name) &&
		Ultima.LastSpell.Name != MySpells.CleanShot.Name &&
		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth &&
		Core.Player.HasAura(856) &&
		Core.Player.HasAura(857) &&
		Core.Player.HasAura(MySpells.HotShot.Name, true, 5000) ||

		Core.Player.CurrentTarget.CurrentHealthPercent < 80 &&
		Actionmanager.HasSpell(MySpells.CleanShot.Name) &&
		Ultima.LastSpell.Name != MySpells.CleanShot.Name &&
		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth &&
		Core.Player.HasAura(856) &&
		Core.Player.HasAura(857) &&
		Core.Player.HasAura(MySpells.HotShot.Name, true, 5000))
            {
                return await MySpells.Reassemble.Cast();
            }
            return false;
        }

        private async Task<bool> Blank()
        {
            if (Ultima.UltSettings.MachinistBlank &&
		Ultima.LastSpell.Name != MySpells.CrossClass.RagingStrikes.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.HawksEye.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.BloodForBlood.Name &&
		Ultima.LastSpell.Name != MySpells.Reload.Name &&
		Ultima.LastSpell.Name != MySpells.Heartbreak.Name &&
		Ultima.LastSpell.Name != MySpells.LegGraze.Name &&
		Ultima.LastSpell.Name != MySpells.Reassemble.Name &&
		Ultima.LastSpell.Name != MySpells.FootGraze.Name &&
		Ultima.LastSpell.Name != MySpells.QuickReload.Name &&
		Ultima.LastSpell.Name != MySpells.RapidFire.Name &&
		Ultima.LastSpell.Name != MySpells.HeadGraze.Name &&
		Ultima.LastSpell.Name != MySpells.Wildfire.Name &&
		Ultima.LastSpell.Name != MySpells.RookAutoturret.Name &&
		Ultima.LastSpell.Name != MySpells.Promotion.Name &&
		Ultima.LastSpell.Name != MySpells.SuppressiveFire.Name &&
		Ultima.LastSpell.Name != MySpells.BishopAutoturret.Name &&
		Ultima.LastSpell.Name != MySpells.Dismantle.Name &&
		Ultima.LastSpell.Name != MySpells.GaussRound.Name &&
		Ultima.LastSpell.Name != MySpells.RendMind.Name &&
		Ultima.LastSpell.Name != MySpells.Hypercharge.Name &&
		Ultima.LastSpell.Name != MySpells.Ricochet.Name)
            {
                if (!Ultima.UltSettings.SmartTarget &&
		    Core.Player.CurrentTarget.MaxHealth <= Core.Player.MaxHealth * 10 &&
		    Core.Player.CurrentTarget.IsFacing(Core.Player) ||

		    !Ultima.UltSettings.SmartTarget &&
		    Core.Player.CurrentTarget.MaxHealth > Core.Player.MaxHealth * 10 &&
		    Core.Player.CurrentTarget.MaxHealth >= Core.Player.MaxHealth &&
		    Ultima.UltSettings.MachinistHeartbreak &&
		    !Actionmanager.CanCast(MySpells.Wildfire.Name, Core.Player.CurrentTarget))
                {
                    return await MySpells.Blank.Cast();
		}
            }
            return false;
        }

        private async Task<bool> SpreadShot()
        {
            if (Helpers.EnemiesNearTarget(8) > 2 &&
		!Core.Player.HasAura(856) &&
		!Core.Player.HasAura(857))
            {
                return await MySpells.SpreadShot.Cast();
            }
            return false;
        }

        private async Task<bool> FootGraze()
        {
            return await MySpells.FootGraze.Cast();
        }

        private async Task<bool> RaidOpenerHotShot()
        {
            if (Core.Player.CurrentTarget.CurrentHealthPercent >= 92 &&
		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 10 &&
		!Core.Player.HasAura(851) &&
		!Core.Player.HasAura(MySpells.HotShot.Name, true, 5000))
            {
                return await MySpells.HotShot.Cast();
            }
            return false;
        }

        private async Task<bool> HotShot()
        {
            if (Ultima.UltSettings.SmartTarget &&
		!Core.Player.HasAura(851) &&
		!Core.Player.HasAura(MySpells.HotShot.Name, true, 5000) ||

		!Core.Player.HasAura(851) &&
		!Core.Player.HasAura(MySpells.HotShot.Name, true, 5000))
            {
                return await MySpells.HotShot.Cast();
            }
            return false;
        }

        private async Task<bool> RapidFire()
        {
            if (Core.Player.HasTarget &&
		Core.Player.InCombat &&
		!Actionmanager.CanCast(MySpells.Reload.Name, Core.Player) &&
		Ultima.LastSpell.Name != MySpells.CrossClass.RagingStrikes.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.HawksEye.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.BloodForBlood.Name &&
		Ultima.LastSpell.Name != MySpells.Reload.Name &&
		Ultima.LastSpell.Name != MySpells.Heartbreak.Name &&
		Ultima.LastSpell.Name != MySpells.LegGraze.Name &&
		Ultima.LastSpell.Name != MySpells.Reassemble.Name &&
		Ultima.LastSpell.Name != MySpells.Blank.Name &&
		Ultima.LastSpell.Name != MySpells.FootGraze.Name &&
		Ultima.LastSpell.Name != MySpells.QuickReload.Name &&
		Ultima.LastSpell.Name != MySpells.HeadGraze.Name &&
		Ultima.LastSpell.Name != MySpells.Wildfire.Name &&
		Ultima.LastSpell.Name != MySpells.RookAutoturret.Name &&
		Ultima.LastSpell.Name != MySpells.Promotion.Name &&
		Ultima.LastSpell.Name != MySpells.SuppressiveFire.Name &&
		Ultima.LastSpell.Name != MySpells.BishopAutoturret.Name &&
		Ultima.LastSpell.Name != MySpells.Dismantle.Name &&
		Ultima.LastSpell.Name != MySpells.GaussRound.Name &&
		Ultima.LastSpell.Name != MySpells.RendMind.Name &&
		Ultima.LastSpell.Name != MySpells.Hypercharge.Name &&
		Ultima.LastSpell.Name != MySpells.Ricochet.Name)
            {
                if (!Actionmanager.HasSpell(MySpells.Wildfire.Name) &&
		    Core.Player.HasAura(MySpells.HotShot.Name, true, 4000) ||

		    Core.Player.CurrentTarget.CurrentHealth <= Core.Player.MaxHealth * 4 &&
		    Actionmanager.HasSpell(MySpells.Wildfire.Name) ||

		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 4 &&
		    Actionmanager.HasSpell(MySpells.Wildfire.Name) &&
		    !Actionmanager.CanCast(MySpells.Wildfire.Name, Core.Player.CurrentTarget))
                {
                    return await MySpells.RapidFire.Cast();
		}
            }
            return false;
        }

        private async Task<bool> HeadGraze()
        {
            if (Ultima.UltSettings.MachinistHeadGraze &&
		Ultima.LastSpell.Name != MySpells.CrossClass.RagingStrikes.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.HawksEye.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.BloodForBlood.Name &&
		Ultima.LastSpell.Name != MySpells.Reload.Name &&
		Ultima.LastSpell.Name != MySpells.Heartbreak.Name &&
		Ultima.LastSpell.Name != MySpells.LegGraze.Name &&
		Ultima.LastSpell.Name != MySpells.Reassemble.Name &&
		Ultima.LastSpell.Name != MySpells.Blank.Name &&
		Ultima.LastSpell.Name != MySpells.FootGraze.Name &&
		Ultima.LastSpell.Name != MySpells.QuickReload.Name &&
		Ultima.LastSpell.Name != MySpells.RapidFire.Name &&
		Ultima.LastSpell.Name != MySpells.Wildfire.Name &&
		Ultima.LastSpell.Name != MySpells.RookAutoturret.Name &&
		Ultima.LastSpell.Name != MySpells.Promotion.Name &&
		Ultima.LastSpell.Name != MySpells.SuppressiveFire.Name &&
		Ultima.LastSpell.Name != MySpells.BishopAutoturret.Name &&
		Ultima.LastSpell.Name != MySpells.Dismantle.Name &&
		Ultima.LastSpell.Name != MySpells.GaussRound.Name &&
		Ultima.LastSpell.Name != MySpells.RendMind.Name &&
		Ultima.LastSpell.Name != MySpells.Hypercharge.Name &&
		Ultima.LastSpell.Name != MySpells.Ricochet.Name)
            {
                if (!Ultima.UltSettings.SingleTarget ||

		    Ultima.UltSettings.SingleTarget &&
		    Core.Player.CurrentTarget.CurrentHealth <= Core.Player.MaxHealth * 4 &&
		    Actionmanager.HasSpell(MySpells.Wildfire.Name) ||

		    Ultima.UltSettings.SingleTarget &&
		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 4 &&
		    Actionmanager.HasSpell(MySpells.Wildfire.Name) &&
		    !Actionmanager.CanCast(MySpells.Wildfire.Name, Core.Player.CurrentTarget))
                {
                    return await MySpells.HeadGraze.Cast();
		}
            }
            return false;
        }

        private async Task<bool> CleanShot()
        {
            if (!Core.Player.HasAura(862) &&
		Core.Player.HasAura(857) ||
		Core.Player.HasAura(857) &&
		Core.Player.HasAura(851) ||
		Core.Player.HasAura(857) &&
		!Core.Player.HasAura(857, false, 5250) ||
		Core.Player.HasAura(857) &&
		!Core.Player.HasAura(857, false, 5250) &&
		Core.Player.HasAura(851) ||
		Core.Player.HasAura(856) &&
		Core.Player.HasAura(857) ||
		Core.Player.HasAura(851) &&
		Core.Player.HasAura(856) &&
		Core.Player.HasAura(857))
            {
                return await MySpells.CleanShot.Cast();
            }
            return false;
        }

        private async Task<bool> Wildfire()
        {
            if (Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 10 &&
		Core.Player.CurrentTarget.HasAura(MySpells.LeadShot.Name, true) &&
		Core.Player.HasAura(MySpells.HotShot.Name) &&
		!Actionmanager.CanCast(MySpells.Hypercharge.Name, Core.Player) &&
		!Actionmanager.CanCast(MySpells.CrossClass.RagingStrikes.Name, Core.Player) &&
		!Actionmanager.CanCast(MySpells.CrossClass.HawksEye.Name, Core.Player) &&
		!Actionmanager.CanCast(MySpells.CrossClass.BloodForBlood.Name, Core.Player))
            {
                return await MySpells.Wildfire.Cast();
            }
            return false;
        }

        private async Task<bool> RookAutoturret()
        {
            if (Ultima.UltSettings.MachinistSummonTurret &&
                Core.Player.HasTarget &&
                Core.Player.CurrentTarget.CanAttack)
            {
                if (Ultima.UltSettings.MachinistRook ||
                    !Actionmanager.HasSpell(MySpells.BishopAutoturret.Name))
                {
                    if (Core.Player.Pet == null ||
                        Core.Player.Pet.Distance2D(Core.Player.CurrentTarget) - Core.Player.CurrentTarget.CombatReach - Core.Player.Pet.CombatReach > 30)
                    {
                        return await MySpells.RookAutoturret.Cast();
                    }
                }
            }
            return false;
        }

        private async Task<bool> TurretRetrieval()
        {
            return await MySpells.TurretRetrieval.Cast();
        }

        private async Task<bool> Promotion()
        {
            return await MySpells.Promotion.Cast();
        }

        private async Task<bool> SuppressiveFire()
        {
            if (Ultima.UltSettings.MachinistHeadGraze &&
		Ultima.LastSpell.Name != MySpells.CrossClass.RagingStrikes.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.HawksEye.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.BloodForBlood.Name &&
		Ultima.LastSpell.Name != MySpells.Reload.Name &&
		Ultima.LastSpell.Name != MySpells.Heartbreak.Name &&
		Ultima.LastSpell.Name != MySpells.LegGraze.Name &&
		Ultima.LastSpell.Name != MySpells.Reassemble.Name &&
		Ultima.LastSpell.Name != MySpells.Blank.Name &&
		Ultima.LastSpell.Name != MySpells.FootGraze.Name &&
		Ultima.LastSpell.Name != MySpells.QuickReload.Name &&
		Ultima.LastSpell.Name != MySpells.RapidFire.Name &&
		Ultima.LastSpell.Name != MySpells.Wildfire.Name &&
		Ultima.LastSpell.Name != MySpells.RookAutoturret.Name &&
		Ultima.LastSpell.Name != MySpells.Promotion.Name &&
		Ultima.LastSpell.Name != MySpells.SuppressiveFire.Name &&
		Ultima.LastSpell.Name != MySpells.BishopAutoturret.Name &&
		Ultima.LastSpell.Name != MySpells.Dismantle.Name &&
		Ultima.LastSpell.Name != MySpells.GaussRound.Name &&
		Ultima.LastSpell.Name != MySpells.RendMind.Name &&
		Ultima.LastSpell.Name != MySpells.Hypercharge.Name &&
		Ultima.LastSpell.Name != MySpells.Ricochet.Name)
            {
                if (!Ultima.UltSettings.SingleTarget ||

		    Ultima.UltSettings.SingleTarget &&
		    Core.Player.CurrentTarget.CurrentHealth <= Core.Player.MaxHealth * 4 &&
		    Actionmanager.HasSpell(MySpells.Wildfire.Name) ||

		    Ultima.UltSettings.SingleTarget &&
		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 4 &&
		    Actionmanager.HasSpell(MySpells.Wildfire.Name) &&
		    !Actionmanager.CanCast(MySpells.Wildfire.Name, Core.Player.CurrentTarget))
                {
                    return await MySpells.SuppressiveFire.Cast();
		}
            }
            return false;
        }

        private async Task<bool> GrenadoShot()
        {
            if (Helpers.EnemiesNearTarget(4) > 2 &&
		!Core.Player.HasAura(856)&&
		!Core.Player.HasAura(857))
            {
                return await MySpells.GrenadoShot.Cast();
            }
            return false;
        }

        private async Task<bool> BishopAutoturret()
        {
            if (Ultima.UltSettings.MachinistSummonTurret &&
                Ultima.UltSettings.MachinistBishop &&
                Core.Player.HasTarget &&
                Core.Player.CurrentTarget.CanAttack)
            {
                if (Core.Player.Pet == null &&
                    Helpers.EnemyUnit.Count(eu => eu.Distance2D(Core.Player.CurrentTarget) - eu.CombatReach - 1 <= 10) >= 2 ||
                    Core.Player.Pet != null &&
                    Core.Player.Pet.Distance2D(Core.Player.CurrentTarget) - Core.Player.CurrentTarget.CombatReach - Core.Player.Pet.CombatReach > 10 &&
                    Helpers.EnemyUnit.Count(eu => eu.Distance2D(Core.Player.CurrentTarget) - eu.CombatReach - 1 <= 10) >= 2)
                {
                    return await MySpells.BishopAutoturret.Cast();
                }
            }
            return false;
        }

        private async Task<bool> Dismantle()
        {
            return await MySpells.Dismantle.Cast();
        }

        private async Task<bool> GaussBarrel()
        {
            if (Ultima.UltSettings.MachinistGaussBarrel &&
                !Core.Player.HasAura(858))
            {
                return await MySpells.GaussBarrel.Cast();
            }
            return false;
        }

        private async Task<bool> GaussRound()
        {
            if (Ultima.LastSpell.Name != MySpells.CrossClass.RagingStrikes.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.HawksEye.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.BloodForBlood.Name &&
		Ultima.LastSpell.Name != MySpells.Reload.Name &&
		Ultima.LastSpell.Name != MySpells.Heartbreak.Name &&
		Ultima.LastSpell.Name != MySpells.LegGraze.Name &&
		Ultima.LastSpell.Name != MySpells.Reassemble.Name &&
		Ultima.LastSpell.Name != MySpells.Blank.Name &&
		Ultima.LastSpell.Name != MySpells.FootGraze.Name &&
		Ultima.LastSpell.Name != MySpells.QuickReload.Name &&
		Ultima.LastSpell.Name != MySpells.RapidFire.Name &&
		Ultima.LastSpell.Name != MySpells.HeadGraze.Name &&
		Ultima.LastSpell.Name != MySpells.Wildfire.Name &&
		Ultima.LastSpell.Name != MySpells.RookAutoturret.Name &&
		Ultima.LastSpell.Name != MySpells.Promotion.Name &&
		Ultima.LastSpell.Name != MySpells.SuppressiveFire.Name &&
		Ultima.LastSpell.Name != MySpells.BishopAutoturret.Name &&
		Ultima.LastSpell.Name != MySpells.Dismantle.Name &&
		Ultima.LastSpell.Name != MySpells.RendMind.Name &&
		Ultima.LastSpell.Name != MySpells.Hypercharge.Name &&
		Ultima.LastSpell.Name != MySpells.Ricochet.Name)
            {
                if (!Ultima.UltSettings.SingleTarget ||

		    Ultima.UltSettings.SingleTarget &&
		    Core.Player.CurrentTarget.CurrentHealth <= Core.Player.MaxHealth * 4 ||

		    Ultima.UltSettings.SingleTarget &&
		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 4 &&
		    !Actionmanager.CanCast(MySpells.Wildfire.Name, Core.Player))
                {
                    return await MySpells.GaussRound.Cast();
		}
            }
            return false;
        }

        private async Task<bool> RendMind()
        {
            return await MySpells.RendMind.Cast();
        }

        private async Task<bool> Hypercharge()
        {
            if (Ultima.UltSettings.MachinistHypercharge &&
		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2 &&
		!Core.Player.CurrentTarget.HasAura(695) &&
		Core.Player.HasTarget &&
		Core.Player.InCombat)
            {
                return await MySpells.Hypercharge.Cast();
            }
            return false;
        }

        private async Task<bool> Ricochet()
        {
            if (Ultima.LastSpell.Name != MySpells.CrossClass.RagingStrikes.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.HawksEye.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.BloodForBlood.Name &&
		Ultima.LastSpell.Name != MySpells.Reload.Name &&
		Ultima.LastSpell.Name != MySpells.Heartbreak.Name &&
		Ultima.LastSpell.Name != MySpells.LegGraze.Name &&
		Ultima.LastSpell.Name != MySpells.Reassemble.Name &&
		Ultima.LastSpell.Name != MySpells.Blank.Name &&
		Ultima.LastSpell.Name != MySpells.FootGraze.Name &&
		Ultima.LastSpell.Name != MySpells.QuickReload.Name &&
		Ultima.LastSpell.Name != MySpells.RapidFire.Name &&
		Ultima.LastSpell.Name != MySpells.HeadGraze.Name &&
		Ultima.LastSpell.Name != MySpells.Wildfire.Name &&
		Ultima.LastSpell.Name != MySpells.RookAutoturret.Name &&
		Ultima.LastSpell.Name != MySpells.Promotion.Name &&
		Ultima.LastSpell.Name != MySpells.SuppressiveFire.Name &&
		Ultima.LastSpell.Name != MySpells.BishopAutoturret.Name &&
		Ultima.LastSpell.Name != MySpells.Dismantle.Name &&
		Ultima.LastSpell.Name != MySpells.GaussRound.Name &&
		Ultima.LastSpell.Name != MySpells.RendMind.Name &&
		Ultima.LastSpell.Name != MySpells.Hypercharge.Name)
            {
                if (!Ultima.UltSettings.SingleTarget ||

		    Ultima.UltSettings.SingleTarget &&
		    Core.Player.CurrentTarget.CurrentHealth <= Core.Player.MaxHealth * 4 ||

	 	    Ultima.UltSettings.SingleTarget &&
		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 4 &&
		    !Actionmanager.CanCast(MySpells.Wildfire.Name, Core.Player))
                {
                    return await MySpells.Ricochet.Cast();
		}
            }
            return false;
        }


        #endregion

        #region Cross Class Spells

        #region Archer

        private async Task<bool> RagingStrikes()
        {
            if (Ultima.UltSettings.MachinistRagingStrikes &&
		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2 &&
		Core.Player.HasTarget &&
		Core.Player.InCombat &&
		Actionmanager.CanCast(MySpells.Wildfire.Name, Core.Player) &&
		!Actionmanager.CanCast(MySpells.Hypercharge.Name, Core.Player))
            {
                return await MySpells.CrossClass.RagingStrikes.Cast();
            }
            return false;
        }

        private async Task<bool> HawksEye()
        {
            if (Ultima.UltSettings.MachinistHawksEye &&
		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2 &&
		Core.Player.HasTarget &&
		Core.Player.InCombat &&
		!Actionmanager.CanCast(MySpells.CrossClass.RagingStrikes.Name, Core.Player))
            {
                return await MySpells.CrossClass.HawksEye.Cast();
            }
            return false;
        }

        private async Task<bool> QuellingStrikes()
        {
            if (Ultima.UltSettings.MachinistQuellingStrikes)
            {
                return await MySpells.CrossClass.QuellingStrikes.Cast();
            }
            return false;
        }

        #endregion

        #region Lancer

        private async Task<bool> Feint()
        {
            if (Ultima.UltSettings.MachinistFeint &&
		MovementManager.IsMoving &&
		Core.Player.HasAura(858) &&
		!Core.Player.HasAura(856) &&
		!Core.Player.HasAura(857) &&
		!Core.Player.HasAura(851))
            {
                return await MySpells.CrossClass.Feint.Cast();
            }
            return false;
        }

        private async Task<bool> KeenFlurry()
        {
            if (Ultima.UltSettings.MachinistKeenFlurry)
            {
                return await MySpells.CrossClass.KeenFlurry.Cast();
            }
            return false;
        }

        private async Task<bool> Invigorate()
        {
            if (Ultima.UltSettings.MachinistInvigorate &&
		Core.Player.HasTarget &&
		Core.Player.InCombat &&
                Core.Player.CurrentTP <= 540)
            {
                return await MySpells.CrossClass.Invigorate.Cast();
            }
            return false;
        }

        private async Task<bool> BloodForBlood()
        {
            if (Ultima.UltSettings.MachinistBloodForBlood &&
		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2 &&
		Core.Player.HasTarget &&
		Core.Player.InCombat &&
		!Actionmanager.CanCast(MySpells.CrossClass.HawksEye.Name, Core.Player) &&
		Ultima.LastSpell.Name != MySpells.CrossClass.HawksEye.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.RagingStrikes.Name)
            {
                return await MySpells.CrossClass.BloodForBlood.Cast();
            }
            return false;
        }

        #endregion

        #endregion

        #region PvP Spells



        #endregion
    }
}